indexing
	description: "Project root class"

class
	TEST

create
	make

feature {NONE} -- Initialization

	make is
			-- Run application.		
		do
			store_point_list
			retrieve_point_list
			io.read_line
		end

feature
	store_point_list is
			-- Store an instance of GLIST[POINT] in the database.
		local
			pntlist : GLIST[POINT]
			p : POINT
			db : IOBJECT_CONTAINER
			closed : BOOLEAN
		do
			create pntlist
			create p.make_with_x_y(1, 2)
			pntlist.put(p)
			create p.make_with_x_y(3, 4)
			pntlist.put(p)
			create p.make_with_x_y(5, 6)
			pntlist.put(p)

			db := {DB_4O_FACTORY}.open_file("test.yap");
			db.set(pntlist)
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

	retrieve_point_list is
			-- Retrieve the objects from the database.
		local
			pntlist, resultlist, next : GLIST[POINT]
			pnt : POINT
			db : IOBJECT_CONTAINER
			results : IOBJECT_SET
			count : INTEGER
			closed : BOOLEAN
		do
			db := {DB_4O_FACTORY}.open_file("test.yap")
			create pntlist
			results := db.get(pntlist)
			if (results /= Void and results.has_next) then
				resultlist ?= results.next
				if (resultlist /= Void) then
					count := resultlist.count
					next := resultlist.next
					pnt := resultlist.item
				end
			end
			closed := db.close
		rescue
			if (db /= Void) then
				closed := db.close
			end
		end

end
